# GHSA-ppf9-4ffw-hh4p: Feathers has an open redirect in OAuth callback enables account takeover

**Severity:** HIGH | **CVSS:** N/A | **Source:** ghsa

## Description

### Description

The `redirect` query parameter is appended to the base origin without validation, allowing attackers to steal access tokens via URL authority injection. This leads to full account takeover, as the attacker obtains the victim's access token and can impersonate them.

The application constructs the final redirect URL by concatenating the base origin with the user-supplied `redirect` parameter:
```javascript
// https://github.com/feathersjs/feathers/blob/dove/packages/authentication-oauth/src/service.ts#L158C3-L176C4
const { redirect } = query;
...
session.redirect = redirect;

// https://github.com/feathersjs/feathers/blob/dove/packages/authentication-oauth/src/strategy.ts#L98
const redirectUrl = `${redirect}${queryRedirect}`;
```

Where:
- `redirect` = base origin from config (e.g., `https://target.com`)
- `queryRedirect` = user input from `?redirect=` parameter

This is exploitable when the `origins` array is configured and origin values do not end with `/`.  An attacker can supply `@attacker.com` as the redirect value results in `https://target.com@attacker.com#access_token=...`, where the browser interprets `attacker.com` as the host, leading to full account takeover.

**Credits**:  Abdelwahed Madani Yousfi (@vvxhid) / Edoardo Geraci (@b0-n0-b0) / Thomas Rinsma (@ThomasRinsma) From Codean Labs.

## Weakness

- [CWE-601](https://cwe.mitre.org/data/definitions/601.html)

## Affected Packages

### @feathersjs/authentication-oauth (npm)
- **Vulnerable:** `<= 5.0.39`
- **Patched:** `5.0.40`

## References

- https://github.com/feathersjs/feathers/security/advisories/GHSA-ppf9-4ffw-hh4p
- https://github.com/feathersjs/feathers/commit/ee19a0ae9bc2ebf23b1fe598a1f7361981b65401
- https://github.com/feathersjs/feathers/releases/tag/v5.0.40
- https://github.com/advisories/GHSA-ppf9-4ffw-hh4p

---

**Source:** https://github.com/advisories/GHSA-ppf9-4ffw-hh4p
**Published:** 2026-02-19
**Ingested:** 2026-02-20 14:43:13 UTC

## Reproduction Steps

_To be determined by the reproduction agent._
